require 'httparty'
require 'thread'
require 'mechanize'
require_relative 'proxy_seeker/proxy'
require_relative 'proxy_seeker/fetcher'
require_relative 'proxy_seeker/tester'
Dir["#{File.dirname(__FILE__)}/proxy_seeker/scrapers/*.rb"].each { |f| require f }

module ProxySeeker
  module_function

  DEFAULTS = { timeout: 3 }

  def find(opts = {})
    opts = DEFAULTS.merge(opts)
    proxies = fetch_proxies(opts)
    proxies = test_proxies(proxies, opts)
    proxies
  end

  def fetch_proxies(opts = {})
    fetcher = ProxySeeker::Fetcher.new(opts)
    fetcher.execute
  end

  def test_proxies(proxies, opts = {})
    tester = ProxySeeker::Tester::new(proxies, opts)
    tester.execute
  end
end