module ProxySeeker
  class Fetcher
    attr_reader :scrapers, :proxies

    def initialize(opts = {})
      @scrapers, @proxies = [], []
      @opts = opts

      Dir["#{File.dirname(__FILE__)}/scrapers/*.rb"].each do |file|
        class_name  = file.split('/').last.split('.rb').first.split('_').map(&:capitalize).join
        class_const = Object.const_get("ProxySeeker::Scrapers::#{class_name}") rescue nil
        @scrapers << class_const if !class_const.nil? && class_const.new.respond_to?(:fetch)
      end
    end

    def execute
      fetch_all
      filer_out
      proxies
    end

    private

    def fetch_all
      scrapers.each do |fetcher|
        @proxies << fetcher.new.fetch
      end

      @proxies = @proxies.flatten.compact
    end

    def filer_out
      @proxies = @proxies.uniq.select{ |proxy| proxy.valid? }
    end
  end
end