require 'resolv'

module ProxySeeker
  class Proxy
    attr_reader :ip, :port, :latency,  :opts

    include Comparable

    def initialize(ip, port, opts = {})
      @ip = ip
      @port = port.to_i
      @latency = opts[:latency]
    end

    def to_s
      "#{ip}:#{port}"
    end

    def valid?
      ip =~ Resolv::IPv4::Regex && port.to_i > 0 ? true : false
    end

    def <=>(other)
      return  0 if latency.nil? && other.latency.nil?
      return  1 if latency.nil? && !other.latency.nil?
      return -1 if !latency.nil? && other.latency.nil?

      latency <=> other.latency
    end
  end
end